import { StringMap } from "./Support";
export declare class ErrorMessage {
    static InternalError: string;
    static MiscJSONParseError: string;
    static MiscReadError: string;
    static MiscUnicodeHighSurrogateWithoutLowSurrogate: string;
    static SchemaArrayIsInvalidSchema: string;
    static SchemaNullIsInvalidSchema: string;
    static SchemaRefMustBeString: string;
    static SchemaAdditionalTypesForbidRequired: string;
    static SchemaNoTypeSpecified: string;
    static SchemaInvalidType: string;
    static SchemaFalseNotSupported: string;
    static SchemaInvalidJSONSchemaType: string;
    static SchemaRequiredMustBeStringOrStringArray: string;
    static SchemaRequiredElementMustBeString: string;
    static SchemaTypeMustBeStringOrStringArray: string;
    static SchemaTypeElementMustBeString: string;
    static SchemaArrayItemsMustBeStringOrArray: string;
    static SchemaIDMustHaveAddress: string;
    static SchemaWrongAccessorEntryArrayLength: string;
    static SchemaSetOperationCasesIsNotArray: string;
    static SchemaCannotFetch: string;
    static SchemaMoreThanOneUnionMemberName: string;
    static SchemaCannotGetTypesFromBoolean: string;
    static SchemaCannotIndexArrayWithNonNumber: string;
    static SchemaIndexNotInArray: string;
    static SchemaKeyNotInObject: string;
    static SchemaFetchError: string;
    static SchemaFetchErrorTopLevel: string;
    static GraphQLNoQueriesDefined: string;
    static DriverUnknownSourceLanguage: string;
    static DriverUnknownOutputLanguage: string;
    static DriverMoreThanOneSchemaGiven: string;
    static DriverCannotInferNameForSchema: string;
    static DriverNoGraphQLQueryGiven: string;
    static DriverNoGraphQLSchemaInDir: string;
    static DriverMoreThanOneGraphQLSchemaInDir: string;
    static DriverSourceLangMustBeGraphQL: string;
    static DriverGraphQLSchemaNeeded: string;
    static DriverInputFileDoesNotExist: string;
    static DriverCannotMixJSONWithOtherSamples: string;
    static DriverCannotMixNonJSONInputs: string;
    static DriverUnknownDebugOption: string;
    static DriverNoLanguageOrExtension: string;
    static DriverCLIOptionParsingFailed: string;
    static IRNoForwardDeclarableTypeInCycle: string;
    static IRTypeAttributesNotPropagated: string;
    static IRNoEmptyUnions: string;
    static RendererUnknownOptionValue: string;
    static TypeScriptCompilerError: string;
}
export declare class QuickTypeError extends Error {
    readonly errorMessage: string;
    readonly messageName: string;
    readonly properties: StringMap;
    constructor(errorMessage: string, messageName: string, userMessage: string, properties: StringMap);
}
export declare function messageError(message: string): never;
export declare function messageError(message: string, properties: StringMap): never;
export declare function messageAssert(assertion: boolean, message: string): void;
export declare function messageAssert(assertion: boolean, message: string, properties: StringMap): void;
