"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var ErrorMessage = /** @class */ (function () {
    function ErrorMessage() {
    }
    ErrorMessage.InternalError = "Internal error: ${message}";
    // Misc
    ErrorMessage.MiscJSONParseError = "Syntax error in ${description} JSON ${address}: ${message}";
    ErrorMessage.MiscReadError = "Cannot read from file or URL ${fileOrURL}: ${message}";
    ErrorMessage.MiscUnicodeHighSurrogateWithoutLowSurrogate = "Malformed unicode: High surrogate not followed by low surrogate";
    // JSON Schema input
    ErrorMessage.SchemaArrayIsInvalidSchema = "An array is not a valid JSON Schema at ${ref}";
    ErrorMessage.SchemaNullIsInvalidSchema = "null is not a valid JSON Schema at ${ref}";
    ErrorMessage.SchemaRefMustBeString = "$ref must be a string, but is an ${actual} at ${ref}";
    ErrorMessage.SchemaAdditionalTypesForbidRequired = "Can't have non-specified required properties but forbidden additionalTypes at ${ref}";
    ErrorMessage.SchemaNoTypeSpecified = "JSON Schema must specify at least one type at ${ref}";
    ErrorMessage.SchemaInvalidType = "Invalid type ${type} in JSON Schema at ${ref}";
    ErrorMessage.SchemaFalseNotSupported = 'Schema "false" is not supported at ${ref}';
    ErrorMessage.SchemaInvalidJSONSchemaType = "Value of type ${type} is not valid JSON Schema at ${ref}";
    ErrorMessage.SchemaRequiredMustBeStringOrStringArray = "`required` must be string or array of strings, but is ${actual} at ${ref}";
    ErrorMessage.SchemaRequiredElementMustBeString = "`required` must contain only strings, but it has ${element}, at ${ref}";
    ErrorMessage.SchemaTypeMustBeStringOrStringArray = "`type` must be string or array of strings, but is ${actual}";
    ErrorMessage.SchemaTypeElementMustBeString = "`type` must contain only strings, but it has ${element}";
    ErrorMessage.SchemaArrayItemsMustBeStringOrArray = "Array items must be an array or an object, but is ${actual}";
    ErrorMessage.SchemaIDMustHaveAddress = "$id ${id} doesn't have an address at ${ref}";
    ErrorMessage.SchemaWrongAccessorEntryArrayLength = "Accessor entry array must have the same number of entries as the ${operation} at ${ref}";
    ErrorMessage.SchemaSetOperationCasesIsNotArray = "${operation} cases must be an array, but is ${cases}, at ${ref}";
    ErrorMessage.SchemaCannotFetch = "Cannot fetch schema at address ${address}";
    ErrorMessage.SchemaMoreThanOneUnionMemberName = "More than one name given for union member: ${names}";
    ErrorMessage.SchemaCannotGetTypesFromBoolean = "Schema value to get top-level types from must be an object, but is boolean, at ${ref}";
    ErrorMessage.SchemaCannotIndexArrayWithNonNumber = "Trying to index array in schema with key that is not a number, but is ${actual} at ${ref}";
    ErrorMessage.SchemaIndexNotInArray = "Index ${index} out of range of schema array at ${ref}";
    ErrorMessage.SchemaKeyNotInObject = "Key ${key} not in schema object at ${ref}";
    ErrorMessage.SchemaFetchError = "Could not fetch schema ${address}, referred to from ${ref}: ${error}";
    ErrorMessage.SchemaFetchErrorTopLevel = "Could not fetch top-level schema ${address}: ${error}";
    // GraphQL input
    ErrorMessage.GraphQLNoQueriesDefined = "GraphQL file doesn't have any queries defined.";
    // Driver
    ErrorMessage.DriverUnknownSourceLanguage = "Unknown source language ${lang}";
    ErrorMessage.DriverUnknownOutputLanguage = "Unknown output language ${lang}";
    ErrorMessage.DriverMoreThanOneSchemaGiven = "More than one schema given for ${name}";
    ErrorMessage.DriverCannotInferNameForSchema = "Cannot infer name for schema ${uri}";
    ErrorMessage.DriverNoGraphQLQueryGiven = "Please specify at least one GraphQL query as input";
    ErrorMessage.DriverNoGraphQLSchemaInDir = "No GraphQL schema in ${dir}";
    ErrorMessage.DriverMoreThanOneGraphQLSchemaInDir = "More than one GraphQL schema in ${dir}";
    ErrorMessage.DriverSourceLangMustBeGraphQL = "If a GraphQL schema is specified, the source language must be GraphQL";
    ErrorMessage.DriverGraphQLSchemaNeeded = "Please specify a GraphQL schema with --graphql-schema or --graphql-introspect";
    ErrorMessage.DriverInputFileDoesNotExist = "Input file ${filename} does not exist";
    ErrorMessage.DriverCannotMixJSONWithOtherSamples = "Cannot mix JSON samples with JSON Schems, GraphQL, or TypeScript in input subdirectory ${dir}";
    ErrorMessage.DriverCannotMixNonJSONInputs = "Cannot mix JSON Schema, GraphQL, and TypeScript in an input subdirectory ${dir}";
    ErrorMessage.DriverUnknownDebugOption = "Unknown debug option ${option}";
    ErrorMessage.DriverNoLanguageOrExtension = "Please specify a language (--lang) or an output file extension";
    ErrorMessage.DriverCLIOptionParsingFailed = "Option parsing failed: ${message}";
    // IR
    ErrorMessage.IRNoForwardDeclarableTypeInCycle = "Cannot resolve cycle because it doesn't contain types that can be forward declared";
    ErrorMessage.IRTypeAttributesNotPropagated = "Type attributes for ${count} types were not carried over to the new graph: ${indexes}";
    ErrorMessage.IRNoEmptyUnions = "Trying to make an empty union - do you have an impossible type in your schema?";
    // Rendering
    ErrorMessage.RendererUnknownOptionValue = "Unknown value ${value} for option ${name}";
    // TypeScript input
    ErrorMessage.TypeScriptCompilerError = "TypeScript error: ${message}";
    return ErrorMessage;
}());
exports.ErrorMessage = ErrorMessage;
/*
type Error =
    | { message: ErrorMessage.InternalError; properties: { message: string } }

    // Misc
    | { message: ErrorMessage.MiscJSONParseError; properties: { description: string; address: string; message: string } }
    | { message: ErrorMessage.MiscReadError; properties: { fileOrURL: string; message: string } }
    | { message: ErrorMessage.MiscUnicodeHighSurrogateWithoutLowSurrogate; properties: {} }

    // JSON Schema input
    | { message: ErrorMessage.SchemaArrayIsInvalidSchema; properties: { ref: Ref } }
    | { message: ErrorMessage.SchemaNullIsInvalidSchema; properties: { ref: Ref } }
    | { message: ErrorMessage.SchemaRefMustBeString; properties: { actual: string; ref: Ref } }
    | { message: ErrorMessage.SchemaAdditionalTypesForbidRequired; properties: { ref: Ref } }
    | { message: ErrorMessage.SchemaNoTypeSpecified; properties: { ref: Ref } }
    | { message: ErrorMessage.SchemaInvalidType; properties: { type: string; ref: Ref } }
    | { message: ErrorMessage.SchemaFalseNotSupported; properties: { ref: Ref } }
    | { message: ErrorMessage.SchemaInvalidJSONSchemaType; properties: { type: string, ref: Ref } }
    | { message: ErrorMessage.SchemaRequiredMustBeStringOrStringArray; properties: { actual: any; ref: Ref } }
    | { message: ErrorMessage.SchemaRequiredElementMustBeString; properties: { element: any; ref: Ref } }
    | { message: ErrorMessage.SchemaTypeMustBeStringOrStringArray; properties: { actual: any } }
    | { message: ErrorMessage.SchemaTypeElementMustBeString; properties: { element: any; ref: Ref } }
    | { message: ErrorMessage.SchemaArrayItemsMustBeStringOrArray; properties: { actual: any; ref: Ref } }
    | { message: ErrorMessage.SchemaIDMustHaveAddress, properties: { id: string; ref: Ref } }
    | { message: ErrorMessage.SchemaWrongAccessorEntryArrayLength, properties: { operation: string; ref: Ref } }
    | { message: ErrorMessage.SchemaSetOperationCasesIsNotArray; properties: { operation: string; cases: any; ref: Ref } }
    | { message: ErrorMessage.SchemaCannotFetch; properties: { address: string } }
    | { message: ErrorMessage.SchemaMoreThanOneUnionMemberName; properties: { names: string[] } }
    | { message: ErrorMessage.SchemaCannotGetTypesFromBoolean; properties: { ref: string } }
    | { message: ErrorMessage.SchemaCannotIndexArrayWithNonNumber; properties: { actual: string; ref: Ref } }
    | { message: ErrorMessage.SchemaIndexNotInArray; properties: { index: number; ref: Ref } }
    | { message: ErrorMessage.SchemaKeyNotInObject; properties: { key: string; ref: Ref } }
    | { message: ErrorMessage.SchemaFetchError; properties: { address: string; ref: Ref; error: any } }
    | { message: ErrorMessage.SchemaFetchErrorTopLevel; properties: { address: string; error: any } }

    // GraphQL input
    | { message: ErrorMessage.GraphQLNoQueriesDefined; properties: {} }

    // Driver
    | { message: ErrorMessage.DriverUnknownSourceLanguage; properties: { lang: string } }
    | { message: ErrorMessage.DriverUnknownOutputLanguage; properties: { lang: string } }
    | { message: ErrorMessage.DriverMoreThanOneSchemaGiven; properties: { name: string } }
    | { message: ErrorMessage.DriverCannotInferNameForSchema; properties: { uri: string } }
    | { message: ErrorMessage.DriverNoGraphQLQueryGiven; properties: {} }
    | { message: ErrorMessage.DriverNoGraphQLSchemaInDir; properties: { dir: string } }
    | { message: ErrorMessage.DriverMoreThanOneGraphQLSchemaInDir; properties: { dir: string } }
    | { message: ErrorMessage.DriverSourceLangMustBeGraphQL; properties: {} }
    | { message: ErrorMessage.DriverGraphQLSchemaNeeded; properties: {} }
    | { message: ErrorMessage.DriverInputFileDoesNotExist; properties: { filename: string } }
    | { message: ErrorMessage.DriverCannotMixJSONWithOtherSamples; properties: { dir: string } }
    | { message: ErrorMessage.DriverCannotMixNonJSONInputs; properties: { dir: string } }
    | { message: ErrorMessage.DriverUnknownDebugOption; properties: { option: string } }
    | { message: ErrorMessage.DriverNoLanguageOrExtension; properties: {} }
    | { message: ErrorMessage.DriverCLIOptionParsingFailed; properties: { message: string } }

    // IR
    | { message: ErrorMessage.IRNoForwardDeclarableTypeInCycle; properties: {} }
    | { message: ErrorMessage.IRTypeAttributesNotPropagated; properties: { count: number, indexes: number[] } }
    | { message: ErrorMessage.IRNoEmptyUnions; properties: {} }

    // Rendering
    | { message: ErrorMessage.RendererUnknownOptionValue; properties: { value: string; name: string } }

    // TypeScript input
    | { message: ErrorMessage.TypeScriptCompilerError; properties: { message: string } }
    ;
*/
/*
type Errors =
   { kind: "foo"; properties: { quux: number } } |
   { kind: "bar"; properties: { frob: boolean } };
type Kind = Errors extends { kind: infer T } ? T : never;
type properties = Errors extends { properties: infer P } ? P : never;
type KindFor<P> = Extract<Errors, { properties: P }> extends { kind: infer K } ? K : never;

const messages: { [kind in Kind]: string } = {
    foo: "Foo error!",
    bar: "A bar is missing!"
};

function error<P extends Props>(kind: KindFor<P>, props: P): void {
    console.log(messages[kind as any], props);
}

error("foo", { quux: 123 });
*/
var QuickTypeError = /** @class */ (function (_super) {
    __extends(QuickTypeError, _super);
    function QuickTypeError(errorMessage, messageName, userMessage, properties) {
        var _this = _super.call(this, userMessage) || this;
        _this.errorMessage = errorMessage;
        _this.messageName = messageName;
        _this.properties = properties;
        return _this;
    }
    return QuickTypeError;
}(Error));
exports.QuickTypeError = QuickTypeError;
function messageError(message, properties) {
    var userMessage = message;
    if (properties !== undefined) {
        for (var _i = 0, _a = Object.getOwnPropertyNames(properties); _i < _a.length; _i++) {
            var name = _a[_i];
            var value = properties[name];
            if (typeof value === "object" && typeof value.toString === "function") {
                value = value.toString();
            }
            else if (typeof value.message === "string") {
                value = value.message;
            }
            else if (typeof value !== "string") {
                value = JSON.stringify(value);
            }
            userMessage = userMessage.replace("${" + name + "}", value);
        }
    }
    else {
        properties = {};
    }
    var messageName;
    var errorMessages = ErrorMessage;
    for (var _b = 0, _c = Object.getOwnPropertyNames(ErrorMessage); _b < _c.length; _b++) {
        var name = _c[_b];
        if (errorMessages[name] === message) {
            messageName = name;
            break;
        }
    }
    if (messageName === undefined) {
        messageName = "UnknownError";
    }
    throw new QuickTypeError(message, messageName, userMessage, properties);
}
exports.messageError = messageError;
function messageAssert(assertion, message, properties) {
    if (assertion)
        return;
    return messageError(message, properties);
}
exports.messageAssert = messageAssert;
