import { Map, OrderedSet } from "immutable";
export declare class TypeAttributeKind<T> {
    readonly name: string;
    private readonly _inIdentity;
    private readonly _uniqueIdentity;
    readonly combine: (a: T, b: T) => T;
    readonly intersect: (a: T, b: T) => T;
    readonly makeInferred: (a: T) => T | undefined;
    readonly stringify: (a: T) => string | undefined;
    constructor(name: string, _inIdentity: boolean, _uniqueIdentity: ((a: T) => boolean) | boolean, combine: ((a: T, b: T) => T) | undefined, intersect: ((a: T, b: T) => T) | undefined, makeInferred: ((a: T) => T | undefined) | undefined, stringify: ((a: T) => string | undefined) | undefined);
    requiresUniqueIdentity(a: T): boolean;
    readonly inIdentity: boolean;
    makeAttributes(value: T): TypeAttributes;
    tryGetInAttributes(a: TypeAttributes): T | undefined;
    private setInAttributes(a, value);
    modifyInAttributes(a: TypeAttributes, modify: (value: T | undefined) => T | undefined): TypeAttributes;
    combineInAttributes(a: TypeAttributes, value: T): TypeAttributes;
    setDefaultInAttributes(a: TypeAttributes, makeDefault: () => T): TypeAttributes;
    equals(other: any): boolean;
    hashCode(): number;
}
export declare type TypeAttributes = Map<TypeAttributeKind<any>, any>;
export declare const emptyTypeAttributes: TypeAttributes;
export declare type CombinationKind = "union" | "intersect";
export declare function combineTypeAttributes(kind: CombinationKind, attributeArray: TypeAttributes[]): TypeAttributes;
export declare function combineTypeAttributes(kind: CombinationKind, a: TypeAttributes, b: TypeAttributes): TypeAttributes;
export declare function makeTypeAttributesInferred(attr: TypeAttributes): TypeAttributes;
export declare const descriptionTypeAttributeKind: TypeAttributeKind<OrderedSet<string>>;
export declare const propertyDescriptionsTypeAttributeKind: TypeAttributeKind<Map<string, OrderedSet<string>>>;
