"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var CSharp_1 = require("./CSharp");
var Golang_1 = require("./Golang");
var CPlusPlus_1 = require("./CPlusPlus");
var Objective_C_1 = require("./Objective-C");
var Java_1 = require("./Java");
var JavaScript_1 = require("./JavaScript");
var TypeScriptFlow_1 = require("./TypeScriptFlow");
var Swift_1 = require("./Swift");
var Elm_1 = require("./Elm");
var JSONSchema_1 = require("./JSONSchema");
var Rust_1 = require("./Rust");
var ruby_1 = require("./ruby");
exports.all = [
    new CSharp_1.default(),
    new Golang_1.default(),
    new Rust_1.default(),
    new CPlusPlus_1.default(),
    new Objective_C_1.default(),
    new Java_1.JavaTargetLanguage(),
    new TypeScriptFlow_1.TypeScriptTargetLanguage(),
    new JavaScript_1.JavaScriptTargetLanguage(),
    new TypeScriptFlow_1.FlowTargetLanguage(),
    new Swift_1.default(),
    new Elm_1.default(),
    new JSONSchema_1.default(),
    new ruby_1.default()
];
function languageNamed(name, targetLanguages) {
    if (targetLanguages === undefined) {
        targetLanguages = exports.all;
    }
    var maybeTargetLanguage = lodash_1.find(targetLanguages, function (l) { return lodash_1.includes(l.names, name) || l.displayName === name; });
    if (maybeTargetLanguage !== undefined)
        return maybeTargetLanguage;
    return lodash_1.find(targetLanguages, function (l) { return l.extension === name; });
}
exports.languageNamed = languageNamed;
